***************************************
* author Brunello Pulix
*        Cagliari (Italy)
*        brunellopulix@yahoo.it
*
***************************************
# include "hbclass.ch"
# include 'common.ch'
# define  CRLF  chr(13)+chr(10)
#translate NTRIM( <v1> ) => ( Ltrim(str(<v1>)) )
*
STATIC oRtf
*
FUNCTION RtfStyle(cLabel,cOpz,cFont,cSize,cColor)
   LOCAL p1 := ""
   LOCAL p2 := ""
   LOCAL p3 := ""
   *
   DEFAULT  cOpz   TO ""
   DEFAULT  cFont  TO "0"
   DEFAULT  cSize  TO "20"
   DEFAULT  cColor TO "0"
   *
   cOpz    :=  Upper(cOpz)
   p1      :=  '{'
   p1      +=  '\f'+cFont
   p2      +=  '\f0'
   p3      :=  "c"
   *
   p1      +=      '\cf'+cColor
   IF 'B'   $ cOpz // bold
      p1      +=      '\b'
      p2      +=      '\b0'
   ENDIF
   IF 'U' $ cOpz // Undeline
      p1      +=      '\ul'
      p2      +=      '\ulnone'
   ENDIF
   IF 'I'  $ cOpz  // Italic
      p1      +=      '\i'
      p2      +=      '\i0'
   ENDIF
   IF 'X'  $ cOpz  // Superscript
      p1      +=      '\super'
      p2      +=      '\nosupersub'
   ENDIF
   IF 'Y'  $ cOpz  // SubScript
      p1      +=      '\sub'
      p2      +=      '\nosupersub'
   ENDIF
   *
   p1      +=      '\fs'+cSize
   p2      +=      '\fs20'
   *
   IF Left(cLabel,1) $ '1234567890'
      p1 += ' '
   ENDIF
   p2 +=  '}'
   *
RETURN p1+cLabel+p2
*
CLASS XRtf
DATA Handle
DATA aTable_P
DATA aTable_L
DATA aTable_P2
DATA aTable_L2
DATA cOrientation
DATA aCoord_P
DATA aCoord_L
DATA aCoord_P2
DATA aCoord_L2
DATA aTable
DATA aCoord
DATA Page
DATA HRow
DATA ItemsCount
DATA CurRow
DATA Symmetric
METHOD New(cFile,aTable,cOrient,cFont,cSize,aCoord,lSymmetric)
METHOD SetOrientation(cOrient)
METHOD Close()
METHOD NewSection()
METHOD WriteFree(obj)
METHOD WriteRow(nTable,aRay)
METHOD WriteBmp(xFile)
METHOD PageHeader(x)
METHOD PageFooter(x)
METHOD NewPage()
METHOD EmptyRow()
METHOD BookMark(cBook,cText)
METHOD HiddenText(x)
METHOD Hyperlink(x)
ENDCLASS

METHOD New(cFile,aTable,cOrient,cFont,cSize,aCoord,lSymmetric) CLASS XRtf
LOCAL i
LOCAL c1
*
Default cOrient    To 'P'
Default cFont      To '0'
Default cSize      To '20'
Default aCoord     To nil
Default lSymmetric To .F.
*
SELF:aCoord_P   := Array(6)
SELF:aCoord_L   := Array(6)
SELF:aCoord_P2  := Array(6)
SELF:aCoord_L2  := Array(6)
SELF:Symmetric  := lSymmetric

SELF:cOrientation       := cOrient
*
IF Upper(cOrient) == 'P'        && PORTRAIT
   *
   Default aCoord TO {210,297,15,15,15,15}
   *
   SELF:aCoord_P[1] := NTrim(Round(aCoord[1]*56.7,0))
   SELF:aCoord_P[2] := NTrim(Round(aCoord[2]*56.7,0))
   SELF:aCoord_L[1] := NTrim(Round(aCoord[2]*56.7,0))
   SELF:aCoord_L[2] := NTrim(Round(aCoord[1]*56.7,0))
   *
ELSE
   *
   Default aCoord To {297,210,15,15,15,15}
   *
   SELF:aCoord_L[1] := NTrim(Round(aCoord[1]*56.7,0))
   SELF:aCoord_L[2] := NTrim(Round(aCoord[2]*56.7,0))
   SELF:aCoord_P[1] := NTrim(Round(aCoord[2]*56.7,0))
   SELF:aCoord_P[2] := NTrim(Round(aCoord[1]*56.7,0))
   *
ENDIF
*
FOR i := 3 TO 6
   SELF:aCoord_P[i] := NTrim(Round(aCoord[i]*56.7,0))
   SELF:aCoord_L[i] := NTrim(Round(aCoord[i]*56.7,0))
NEXT
*
If SELF:Symmetric
   SELF:aCoord_P2[1] :=SELF:aCoord_P[1]
   SELF:aCoord_P2[2] :=SELF:aCoord_P[2]
   SELF:aCoord_P2[3] :=SELF:aCoord_P[4]
   SELF:aCoord_P2[4] :=SELF:aCoord_P[3]
   SELF:aCoord_P2[5] :=SELF:aCoord_P[5]
   SELF:aCoord_P2[6] :=SELF:aCoord_P[6]
   *
   SELF:aCoord_L2[1] :=SELF:aCoord_L[1]
   SELF:aCoord_L2[2] :=SELF:aCoord_L[2]
   SELF:aCoord_L2[3] :=SELF:aCoord_L[4]
   SELF:aCoord_L2[4] :=SELF:aCoord_L[3]
   SELF:aCoord_L2[5] :=SELF:aCoord_L[5]
   SELF:aCoord_L2[6] :=SELF:aCoord_L[6]
Endif
*
SELF:aTable_P  := {}
SELF:aTable_L  := {}
SELF:aTable_P2 := {}
SELF:aTable_L2 := {}
*
FOR i := 1 TO Len(aTable)
   AAdd(SELF:aTable_P,MakeList(MakeTable(aTable[i],SELF:aCoord_P)))
   AAdd(SELF:aTable_L,MakeList(MakeTable(aTable[i],SELF:aCoord_L)))
   *
   If SELF:Symmetric
      AAdd(SELF:aTable_P2,MakeList(MakeTable(aTable[i],SELF:aCoord_P2)))
      AAdd(SELF:aTable_L2,MakeList(MakeTable(aTable[i],SELF:aCoord_L2)))
   Endif
   *
NEXT
*
SELF:Handle := FCreate(cFile,0)
FWrite(SELF:Handle,"{\rtf1\ansi{\fonttbl")
FWrite(SELF:Handle,"{\f0\fswiss Arial;}")
FWrite(SELF:Handle,"{\f1\fswiss Helv;}")
FWrite(SELF:Handle,"{\f2\froman Times New Roman;}")
FWrite(SELF:Handle,"{\f3\froman Courier;}")
FWrite(SELF:Handle,"{\f4\froman Roman;}")
FWrite(SELF:Handle,"{\f5\fmodern Modern;}")
FWrite(SELF:Handle,"{\f6\froman MS LineDraw;}")
FWrite(SELF:Handle,"{\f7\froman AdvOCR-B;}")
FWrite(SELF:Handle,"{\f8\froman Lucida Console;}")
FWrite(SELF:Handle,"{\f9\froman Courier New;}")
FWrite(SELF:Handle,"{\f10\fswiss Tw Cen MT CE;}")
FWrite(SELF:Handle,"}"+CRLF)
*
FWrite(SELF:Handle,"{\colortbl\red0\green0\blue0;\red128")
FWrite(SELF:Handle,"\green0\blue0;\red0\green128\blue0;\red128")
FWrite(SELF:Handle,"\green128\blue0;\red0\green0\blue128;\red128")
FWrite(SELF:Handle,"\green0\blue128;\red0\green128\blue128;\red128")
FWrite(SELF:Handle,"\green128\blue128;\red192\green192\blue192;\red255")
FWrite(SELF:Handle,"\green0\blue0;\red0\green255\blue0;\red255\green255")
FWrite(SELF:Handle,"\blue0;\red0\green0\blue255;\red255\green0\blue255;\red0\green255\blue255;}"+CRLF)
*
c1 := "{\info{\author "+GetEnv('USERNAME')+"}"
c1 += "{\creatim "
c1 += "\yr"+NTrim(Year(date()))
c1 += "\mo"+NTrim(Month(date()))
c1 += "\dy"+NTrim(Day(date()))
c1 += "\hr"+Left(Time(),2)
c1 += "\min"+SubStr(Time(),4,2)
c1 += "}}"
*
FWrite(SELF:Handle,c1+CRLF)
*
FWrite(SELF:Handle,"\f"+cFont+"\fs"+cSize+CRLF)

SELF:Page       := 1
SELF:HRow       := NTrim(Round(05*56.7,0))
SELF:ItemsCount := if(cOrient=='P',55,38)
SELF:CurRow     := 0
SELF:SetOrientation(cOrient)
*
RETURN SELF
*
METHOD SetOrientation(cOrient) CLASS XRtf
Local a1,a2
*
a1 := array(6)
a2 := array(6)
*
a1[1] := SELF:aCoord_P[1]
a1[2] := SELF:aCoord_P[2]
a1[3] := SELF:aCoord_P[3]
a1[4] := SELF:aCoord_P[4]
a1[5] := SELF:aCoord_P[5]
a1[6] := SELF:aCoord_P[6]
*
a2[1] := SELF:aCoord_L[1]
a2[2] := SELF:aCoord_L[2]
a2[3] := SELF:aCoord_L[3]
a2[4] := SELF:aCoord_L[4]
a2[5] := SELF:aCoord_L[5]
a2[6] := SELF:aCoord_L[6]
*
If SELF:Symmetric .and. SELF:Page%2 > 0
   *
   a1[1] := SELF:aCoord_P2[1]
   a1[2] := SELF:aCoord_P2[2]
   a1[3] := SELF:aCoord_P2[3]
   a1[4] := SELF:aCoord_P2[4]
   a1[5] := SELF:aCoord_P2[5]
   a1[6] := SELF:aCoord_P2[6]
   *
   a2[1] := SELF:aCoord_L2[1]
   a2[2] := SELF:aCoord_L2[2]
   a2[3] := SELF:aCoord_L2[3]
   a2[4] := SELF:aCoord_L2[4]
   a2[5] := SELF:aCoord_L2[5]
   a2[6] := SELF:aCoord_L2[6]
   *
Endif
*
SELF:cOrientation := Upper(cOrient)
*
SELF:aTable := {}
IF cOrient == 'P'
   FWrite(SELF:Handle,;
   "\paperw" +a1[1]+;
   " \paperh"+a1[2]+;
   " \margl" +a1[3]+;
   " \margr" +a1[4]+;
   " \margt" +a1[5]+;
   " \margb" +a1[6]+''+CRLF)
   If SELF:Symmetric
      SELF:aTable := SELF:aTable_P2
   else
      SELF:aTable := SELF:aTable_P
   Endif
ELSE
   FWrite(SELF:Handle,;
   "\paperw" +a2[1]+;
   " \paperh"+a2[2]+;
   " \margl" +a2[3]+;
   " \margr" +a2[4]+;
   " \margt" +a2[5]+;
   " \margb" +a2[6]+'\landscape'+CRLF)
   If SELF:Symmetric
      SELF:aTable := SELF:aTable_L2
   else
      SELF:aTable := SELF:aTable_L
   endif
ENDIF
FWrite(SELF:Handle,"\sectd \linex0 \sa10"+CRLF)
*
RETURN SELF

METHOD Close() CLASS XRtf
FWrite(SELF:Handle,"}"+CRLF)
FClose(SELF:Handle)
RETURN SELF
*
METHOD WriteRow(nTable,aRay) CLASS XRtf
LOCAL j
LOCAL a1
LOCAL c1 := ''
LOCAL xx
LOCAL xSize
Local aCargo
Local i
Local cOpz
Local cStr
*
IF nTable == 0  && riga vuota
   IF Empty(aRay)
      FWrite(SELF:Handle,"\pard\plain \ql \txttrn {\f0\fs20  }\par"+CRLF)
   ENDIF
   RETURN SELF
ENDIF
*
cStr := ""
IF !Empty(SELF:aTable)
   FOR j := 1 TO Len(aRay)
      IF j == 1
         a1 := StToAr(SELF:aTable[nTable,1],';')
         xx := 1
         c1 += a1[xx++]
      ENDIF
      IF aRay[j]:VertTop
         c1 += " \clvertalt" && allinea in alto il contenuto della cella
         ELSEIF aRay[j]:VertCenter
         c1 += " \clvertalc" && centra vert. il contenuto della cella
      ELSE
         c1 += " \clvertalb" && allinea in basso il contenuto della cella
      ENDIF
      *
      IF !Empty(aRay[j]:Cargo)
         *
         aCargo := {}
         If ';' $ aRay[j]:Cargo
            aCargo := StToAr(aRay[j]:Cargo,';')
         else
            aadd(aCargo,aRay[j]:Cargo)
         Endif
         *
         For i := 1 To Len(aCargo)
            *
            cOpz := aCargo[i]
            *
            If Left(cOpz,1) == 'A'
               c1 += GetCargo(cOpz,[\cl])
               elseif Left(cOpz,1) == 'B'
               c1 += GetCargo2(cOpz)
               elseif Left(cOpz,1) == 'D'
               c1 += [\cltxbtlr]
               elseif Left(cOpz,1) == 'E'
               c1 += [\cltxtbrl]
               elseif Left(cOpz,1) == 'F'
               c1 += [\clvmrg\clvmgf\cltxbtlr ]
               elseif Left(cOpz,1) == 'G'
               c1 += [\clvmrg ]
               elseif Left(cOpz,1) == 'H'
               c1 += [\trrh]+NTrim(Round(val(substr(cOpz,2))*56.7,0))
            Endif
            *
         Next
      ENDIF
      ** Creazione dei Bordi
      IF !Empty(aRay[j]:Border)
         xSize := '1' //aRay[j]:Size
         IF "Q" $ aRay[j]:Border
            xSize := '20' //NTrim(Val(xSize)*2)
         ENDIF
         IF "T" $ aRay[j]:Border
            c1 += " \clbrdrt\brdrs\brdrw"+xSize
         ENDIF
         IF "L" $ aRay[j]:Border
            c1 += " \clbrdrl\brdrs\brdrw"+xSize
         ENDIF
         IF "R" $ aRay[j]:Border
            c1 += " \clbrdrr\brdrs\brdrw"+xSize
         ENDIF
         IF "B" $ aRay[j]:Border
            c1 += " \clbrdrb\brdrs\brdrw"+xSize
         ENDIF
      ENDIF
      c1 += " "+a1[xx++]
   NEXT
ENDIF
cStr += c1
*
FOR j := 1 TO Len(aRay)
   IF  ValType(aRay[j]:Label) == 'B'
      cStr += Eval(aRay[j]:Label)
   ELSE
      cStr += "\pard\plain\intbl \sa10\sl"+SELF:HRow
      cStr += "\q"+aRay[j]:Alignment+"\txttrn"
      *
      IF !Empty(aRay[j]:BackClr)
         cStr += "\cbpat"+aRay[j]:BackClr+' '
      ENDIF
      cStr += " {"
      IF !Empty(aRay[j]:Color)
         cStr += "\cf"+aRay[j]:Color
      ENDIF
      IF aRay[j]:Bold
         cStr += "\b"
      ENDIF
      IF aRay[j]:Underline
         cStr += "\ul"
      ENDIF
      IF aRay[j]:Italic
         cStr += "\i"
      ENDIF
      IF Empty(aRay[j]:Label)
         cStr += "\f0\fs10\sl10 }"
      ELSE
         cStr += "\f"+aRay[j]:font+"\fs"+aRay[j]:Size+"\sl"+SELF:HRow
         IF  "|" $ aRay[j]:Label
            cStr += " "+StrTran(aRay[j]:Label,'|','\par ')+"}"
         ELSE
            cStr += " "+aRay[j]:Label+"}"
         ENDIF
      ENDIF
      IF aRay[j]:Page
         cStr += "{\f"+aRay[j]:font+"\fs"+aRay[j]:Size+' '+NTrim(SELF:Page)+"}"
      ENDIF
      IF aRay[j]:Day
         cStr += "{\f"+aRay[j]:font+"\fs"+aRay[j]:Size+' '+DToC(date())+"}"
      ENDIF
   ENDIF
   cStr += "\cell"+CRLF
NEXT
cStr += "\row"+CRLF
FWrite(SELF:Handle,cStr)
SELF:CurRow:=SELF:CurRow+1
*
RETURN SELF

METHOD NewSection() CLASS XRtf
FWrite(SELF:Handle,"\pard\plain \sect\sectd"+CRLF)
SELF:Page:=SELF:Page+1
SELF:CurRow := 0
*
RETURN SELF
*
METHOD WriteFree(obj) CLASS XRtf
Local cOpz
Local aCargo
Local c1
Local i
Local cStr
*
cStr := ""
*
cStr += "\pard\plain "
cStr += "\q"+obj:Alignment+"\txttrn"
IF !Empty(obj:BackClr)
   cStr += "\cbpat"+obj:BackClr+' '
ENDIF
IF !Empty(obj:Cargo)
   aCargo := {}
   If ';' $ obj:Cargo
       aCargo := StToAr(obj:Cargo,';')
   else
       aadd(aCargo,obj:Cargo)
   Endif
   *
   For i := 1 To Len(aCargo)
   cOpz := aCargo[i]
   If Left(cOpz,1) == 'A'
      cStr += GetCargo(cOpz)
      elseIf Left(cOpz,1) == 'C'
      cStr += GetCargo3(cOpz)
      elseIf Left(cOpz,1) == 'I'
      cStr += [\li]+NTrim(Round(val(substr(cOpz,2))*56.7,0))
      elseIf Left(cOpz,1) == 'K'
      cStr += [\ri]+NTrim(Round(val(substr(cOpz,2))*56.7,0))
      elseIf Left(cOpz,1) == 'J'
      c1 := If('-'$cOpz,'-','')
      cOpz := strtran(cOpz,'-','')
      cStr += [\fi]+c1+NTrim(Round(val(substr(cOpz,2))*56.7,0))
      elseIf Left(cOpz,1) == 'L'
      cStr += [\sb]+NTrim(Round(val(substr(cOpz,2))*56.7,0))
      elseIf Left(cOpz,1) == 'M'
      cStr += [\sa]+NTrim(Round(val(substr(cOpz,2))*56.7,0))
   endif
   Next
ENDIF
cStr += " {"
IF !Empty(obj:Color)
   cStr += "\cf"+obj:Color
ENDIF
IF obj:Bold
   cStr += "\b"
ENDIF
IF obj:Underline
   cStr += "\ul"
ENDIF
IF obj:Italic
   cStr += "\i"
ENDIF
cStr += "\f"+obj:font+"\fs"+obj:Size
IF  "|" $ obj:Label
   cStr += " "+StrTran(obj:Label,'|','\par ')+"}"
ELSE
   cStr += " "+obj:Label+"}"
ENDIF
cStr += "\par"+CRLF
*
FWrite(self:Handle,cStr)
*
RETURN SELF
*
METHOD WriteBmp(xFile) CLASS XRtf
LOCAL y
LOCAL z
LOCAL x
*
x := FOpen(xFile,0)
y := FSeek(x,0,2)
FSeek(x,0)
DO WHILE .T.
   z := FReadStr(x,1024)
   FWrite(SELF:Handle,z)
   IF Len(z) < 100
      EXIT
   ENDIF
ENDDO
FWrite(SELF:Handle,CRLF)
FClose(x)
*
RETURN SELF
*
METHOD PageHeader(x) CLASS XRtf
FWrite(SELF:Handle,"{\header\ql "+x+"}"+CRLF)
RETURN SELF
*
METHOD PageFooter(x) CLASS XRtf
FWrite(SELF:Handle,"{\footer\ql "+x+"}"+CRLF)
RETURN SELF
*
METHOD NewPage() CLASS XRtf
FWrite(SELF:Handle,"\pard\plain \ql \txttrn {\f0\fs18 \par\page}"+CRLF)
SELF:Page:=SELF:Page+1
SELF:CurRow := 0
RETURN SELF
*
METHOD EmptyRow() CLASS XRtf
RETURN SELF:WriteRow(0,{})
*
STATIC FUNCTION MakeList(aTbl)
LOCAL i
LOCAL n
LOCAL h
LOCAL aRay
LOCAL Stringa
*
aRay    :=      {}
h := 72
*
FOR n := 1 TO Len(aTbl)
   stringa := "\trowd\trgaph"+NTrim(h)+"\trleft-"+NTrim(h)
   FOR i := 1 TO Len(aTbl[n])
      stringa += ";\cellx"+NTrim(aTbl[n,i])
   NEXT
   AAdd(aRay,Stringa)
NEXT
*
RETURN aRay
*
METHOD BookMark(cBook,cText) CLASS XRtf
FWrite(SELF:Handle,"{\*\bkmkstart "+cBook+"} "+cText+"{\*\bkmkend "+cBook+"}")
RETURN SELF
*
METHOD HiddenText(x) CLASS XRtf
FWrite(SELF:Handle,"{\v "+x+"}")
RETURN SELF
*
METHOD Hyperlink(x) CLASS XRtf
 FWrite(SELF:Handle,"{\field{\*\fldinst{HYPERLINK "+x+"}}{\fldrslt{\ulstuff}}}")
Return self
*
STATIC FUNCTION MakeTable(aTemp,aCoord)
LOCAL aRay
LOCAL aTbl
LOCAL i
LOCAL x
LOCAL y
LOCAL k
LOCAL j
*
j := Val(aCoord[1])-(Val(aCoord[4])+Val(aCoord[3]))
*
aRay   := {}
aTbl   := {}
y := j/100
k := 0
FOR i := 1 TO Len(aTemp)
   x := y*aTemp[i]
   k += x
   IF i == Len(aTemp) .and. k < j
      k := j
   ENDIF
   AAdd(aRay,Int(k))
NEXT
AAdd(aTbl,aRay)
*
RETURN aTbl
*
*
Static Function GetCargo(c,c2)
Local cRet
*
Default c2 To [\]
*
If c == [A10]
   cRet := c2+[bghoriz]
   elseIf c == [A11]
   cRet := c2+[bgvert]
   elseIf c == [A12]
   cRet := c2+[bgfdiag]
   elseIf c == [A13]
   cRet := c2+[bgbdiag]
   elseIf c == [A14]
   cRet := c2+[bgcross]
   elseIf c == [A15]
   cRet := c2+[bgdcross]
   elseIf c == [A16]
   cRet := c2+[bgdkhoriz]
   elseIf c == [A17]
   cRet := c2+[bgdkvert]
   elseIf c == [A18]
   cRet := c2+[bgdkfdiag]
   elseIf c == [A19]
   cRet := c2+[bgdkbdiag]
   elseIf c == [A20]
   cRet := c2+[bgdkcross]
   elseIf c == [A21]
   cRet := c2+[bgdkdcross]
   elseIf c == [A22]
   cRet := c2+[bgdcross]
Else
   cRet := []
Endif
*
Return cRet
*
Static Function GetCargo2(c)
Local cRet
*
If c == [B10]
   cRet := [\clshdngraw1000]
   elseIf c == [B15]
   cRet := [\clshdngraw1500]
   elseIf c == [B20]
   cRet := [\clshdngraw2000]
   elseIf c == [B25]
   cRet := [\clshdngraw2500]
   elseIf c == [B30]
   cRet := [\clshdngraw3000]
Else
   cRet := []
Endif
*
Return cRet
*
Static Function GetCargo3(c)
Local cRet
*
If c == [C10]
   cRet := [\shading1000]
   elseIf c == [C15]
   cRet := [\shading1500]
   elseIf c == [C20]
   cRet := [\shading2000]
   elseIf c == [C25]
   cRet := [\shading2500]
   elseIf c == [C30]
   cRet := [\shading3000]
   
Else
   cRet := []
Endif
*
Return cRet
*

PROCEDURE RTF_OPEN(cFile,aTable,cOrient,cFont,cSize,aCoord,lSymmetric)
   *
   Default cOrient    To 'P'
   Default cFont      To '0'
   Default cSize      To '20'
   Default lSymmetric To .F.
   *
   oRtf := XRTF():New(cFile,aTable,cOrient,cFont,cSize,aCoord,lSymmetric)
   *
RETURN
*
PROCEDURE RTF_PageFooter(x)
   oRtf:PageFooter(x)
RETURN
*
PROCEDURE RTF_PageHeader(x)
   oRtf:PageHeader(x)
RETURN
*
PROCEDURE RTF_SetOrientation(cOrient)
   oRtf:SetOrientation(cOrient)
RETURN
*
PROCEDURE RTF_WriteFree(obj)
   oRtf:WriteFree(obj)
RETURN
*
PROCEDURE RTF_WRITEROW(nTab,aRay)
   oRtf:WriteRow(nTab,aRay)
RETURN
*
FUNCTION RTF_CURROW()
RETURN oRtf:CurRow
*
FUNCTION RTF_WriteBmp(xFile)
   oRtf:WriteBmp(xFile)
Return
*
PROCEDURE RTF_BookMark(cBook,cText)
   oRtf:BookMark(cBook,cText)
RETURN
*
PROCEDURE RTF_CLOSE()
   oRtf:Close()
RETURN
*
PROCEDURE RTF_EMPTYROW()
   oRtf:EmptyRow()
RETURN
*
PROCEDURE RTF_HiddenText(x)
   oRtf:HiddenText(x)
RETURN
*
PROCEDURE RTF_NEWSECTION()
   oRtf:NewSection()
RETURN
*
PROCEDURE RTF_Hyperlink(x)
   oRtf:Hyperlink(x)
RETURN
*


